#include <iostream>
#include "stdio.h"
#include "musicback.h"
#include <math.h>
#include <string>

using namespace std;

#include "fmod/fmod.h"
#include "fmod/fmod_errors.h"

#define DISTANCEFACTOR       1.0f    // Units per meter.  I.e feet would = 3.28.  centimeters would = 100.
            

	FMOD_SYSTEM* fmod_system;
    
	unsigned int      version;
	


FMOD_CHANNEL*	music_channel[MUSICCOUNT];
FMOD_DSP* dsp[MUSICCOUNT];

float t=0;
void ERRCHECK(FMOD_RESULT result)
{
    if (result != FMOD_OK)
    {
        printf("FMOD error! (%d) %s\n", result, FMOD_ErrorString(result));
        exit(-1);
    }
}


void set_emitter(int i,float vol,float pan, float freq)
{
	FMOD_RESULT      result;
	
//	result = FMOD_DSP_SetParameter(dsp[i], FMOD_DSP_OSCILLATOR_RATE, freq);
//	ERRCHECK(result);
	FMOD_Channel_SetVolume(music_channel[i], vol);
	FMOD_Channel_SetPan(music_channel[i], pan);
	
}

void
init_sound()
{
                FMOD_RESULT      result;
              result = FMOD_System_Create(&fmod_system);
                  FMOD_SPEAKERMODE speakermode;
    FMOD_CAPS        caps;
        char             name[256];
    ERRCHECK(result);
    
    result = FMOD_System_GetVersion(fmod_system, &version);
    ERRCHECK(result);

    if (version < FMOD_VERSION)
    {
        printf("Error!  You are using an old version of FMOD %08x.  This program requires %08x\n", version, FMOD_VERSION);
    }
    result = FMOD_System_GetDriverCaps(fmod_system, 0, &caps, 0, 0, &speakermode);
    ERRCHECK(result);

    result = FMOD_System_SetSpeakerMode(fmod_system, speakermode);       /* Set the user selected speaker mode. */
    ERRCHECK(result);

    if (caps & FMOD_CAPS_HARDWARE_EMULATED)             /* The user has the 'Acceleration' slider set to off!  This is really bad for latency!. */
    {                                                   /* You might want to warn the user about this. */
        result = FMOD_System_SetDSPBufferSize(fmod_system, 1024, 10);
        ERRCHECK(result);
    }

    result = FMOD_System_GetDriverInfo(fmod_system, 0, name, 256, 0);
    ERRCHECK(result);

    if (strstr(name, "SigmaTel"))   /* Sigmatel sound devices crackle for some reason if the format is PCM 16bit.  PCM floating point output seems to solve it. */
    {
        result = FMOD_System_SetSoftwareFormat(fmod_system, 48000, FMOD_SOUND_FORMAT_PCMFLOAT, 0,0, FMOD_DSP_RESAMPLER_LINEAR);
        ERRCHECK(result);
    }

    result = FMOD_System_Init(fmod_system, 100, FMOD_INIT_NORMAL, 0);
    if (result == FMOD_ERR_OUTPUT_CREATEBUFFER)         /* Ok, the speaker mode selected isn't supported by this soundcard.  Switch it back to stereo... */
    {
        result = FMOD_System_SetSpeakerMode(fmod_system, FMOD_SPEAKERMODE_STEREO);
        ERRCHECK(result);
                
        result = FMOD_System_Init(fmod_system, 100, FMOD_INIT_NORMAL, 0);/* ... and re-init. */
        ERRCHECK(result);
    }


    for (int i=0;i<MUSICCOUNT;i++)
    {
        music_channel[i]=0;
		result = FMOD_System_CreateDSPByType(fmod_system, FMOD_DSP_TYPE_OSCILLATOR, &dsp[i]);
		ERRCHECK(result);
		result = FMOD_DSP_SetParameter(dsp[i], FMOD_DSP_OSCILLATOR_RATE, 220.0f*freqs[i/9][i%9]);
		ERRCHECK(result);
		result = FMOD_DSP_SetParameter(dsp[i], FMOD_DSP_OSCILLATOR_TYPE, types[i/9][i%9]);
		ERRCHECK(result);
		result = FMOD_System_PlayDSP(fmod_system, FMOD_CHANNEL_REUSE, dsp[i], true, &music_channel[i]);
		ERRCHECK(result);
		FMOD_Channel_SetVolume(music_channel[i], 0.5f);
		FMOD_Channel_SetPaused(music_channel[i], false);

    }

}

void stop_music()
{
     for (int j=0;j<MUSICCOUNT;j++)
     {
        FMOD_Channel_Stop(music_channel[j]);        
     }

}

void release_sound()
{
	
    for (int i=0;i<MUSICCOUNT;i++)     
		FMOD_DSP_Release(dsp[i]);        
	
    FMOD_System_Close(fmod_system);
    FMOD_System_Release(fmod_system);
}

